;;; $Id$
;;; Bigloo specific prologue.

;;; use SRFI-18 with-exception-handler
;;; En fait plutot (with-handler handler form ...)
;;; avec handler = (lambda (exc) ...)

;;; handler2string: Exception -> String
(define (handler2string e) 
  (with-access::&error e (msg obj)
     (let ((msg (string-append (->string msg) " " (->string obj))))
       ;(display msg); DEBUG
       msg ) ) )

(define (li101-error code . msgs)
  (let ((s (apply ->string* msgs)))
    ;;(display `("RAISING: " , code ,s));DEBUG
    (error 'li101-error (->string* "ERREUR " code) s) ) )

(define (li101-throw-error code . msgs)
  (let ((s (apply ->string* msgs)))
    ;;(display `("RAISING: " , code ,s));DEBUG
    (error 'li101-throw-error code s) ) )

;;; handler2pair: Exception -> (Exception String)
(define (handler2pair e)
  (with-access::&error e (msg obj)
     ;(write `(---------handler2pair ,e ,msg ,obj));DEBUG
     (if (number? msg)
         (list msg (->string obj))
         (list (->string msg) (->string obj)) ) ) )

;;; li101-try: Thunk -> (NormalResult) + (abnormal result)
;;; invoke the thunk and return a list of one value if ok or a list
;;; of two values if an exception arrived.
(define (li101-try thunk)
  (let ((li101-result (with-handler handler2pair
                           (list (thunk)) ) ))
    ;(print `(li101-try result: ,li101-result)); DEBUG
    li101-result ) )

(define (->string* . o*)
  (define (convert c)
    (cond ((char=? c #\<) (string->list "&lt;"))
          ((char=? c #\>) (string->list "&gt;"))
          (else (list c)) ) )
  (let ((msg (with-output-to-string 
              (lambda () (for-each (lambda (o)
                                     (display " ")
                                     (display o) )
                                   o* )) ) ))
    (list->string
     (append-map convert
                 (string->list msg) ) ) ) )

(define (->string o)
  (define (convert c)
    (cond ((char=? c #\<) (string->list "&lt;"))
          ((char=? c #\>) (string->list "&gt;"))
          (else (list c)) ) )
  (let ((msg (with-output-to-string (lambda () 
                                      (display o) ))))
    (list->string
     (append-map convert
                 (string->list msg) ) ) ) )

;;; (->string "abc")
;;; (->string "abc>d")
;;; (->string "abc<de")
;;; (->string '(ab c))

;;; reduce in Bigloo is slightly different!
;;; However we cannot redefine it. This is harmless since li101 has its
;;; own interpreter.
'''
(set! reduce 
      (let ()
        (define (reduce fn base L)
          (if (pair? L)
              (fn (car L) 
                  (reduce fn base (cdr L)))
              base ) )
        reduce ) )

;;; end of pre-bigloo.scm
